/* <begin connected objects> */
/*
This file is auto generated by pgrx.

The ordering of items is not stable, it is driven by a dependency graph.
*/
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:21
CREATE TABLE example_products (
    product_id SERIAL PRIMARY KEY,
    product_name TEXT NOT NULL,
    description TEXT,
    product_category TEXT NOT NULL,
    price DECIMAL(10, 2) NOT NULL,
    last_updated_at TIMESTAMP WITH TIME ZONE DEFAULT CURRENT_TIMESTAMP
);

INSERT INTO example_products(product_name, description, product_category, price, last_updated_at) VALUES
('Pencil', 'Utensil used for writing and often works best on paper', 'stationery', 1.50, NOW()),
('Laptop Stand', 'Elevated platform for laptops, enhancing ergonomics', 'electronics', 35.99, NOW()),
('Desk Lamp', 'Illumination device for workspaces, often adjustable', 'furniture', 22.50, NOW()),
('Bluetooth Speaker', 'Portable audio device with wireless connectivity', 'electronics', 99.99, NOW()),
('Water Bottle', 'Reusable container for liquids, often insulated', 'kitchenware', 15.00, NOW()),
('Backpack', 'Storage solution for carrying personal items on one’s back', 'accessories', 45.00, NOW()),
('Wireless Mouse', 'Pointing device without the need for a physical connection', 'electronics', 25.00, NOW()),
('Plant Pot', 'Container for holding plants, often with drainage', 'garden', 12.00, NOW()),
('Sunglasses', 'Protective eyewear to shield eyes from UV rays', 'accessories', 50.00, NOW()),
('Notebook', 'Bound sheets of paper for note-taking or sketching', 'stationery', 3.99, NOW()),
('Stylus Pen', 'Tool for touchscreen devices, mimics finger touch', 'electronics', 18.50, NOW()),
('Travel Mug', 'Insulated container for beverages on-the-go', 'kitchenware', 10.99, NOW()),
('Phone Charger', 'Device to replenish the battery of mobile phones', 'electronics', 20.00, NOW()),
('Yoga Mat', 'Cushioned surface for practicing yoga or exercise', 'sports', 30.00, NOW()),
('Wall Clock', 'Time-telling device meant to hang on walls', 'furniture', 15.50, NOW()),
('Keychain', 'Small device for holding keys together', 'accessories', 5.00, NOW()),
('Desk Organizer', 'Tool for sorting and storing desk items', 'furniture', 12.50, NOW()),
('Earbuds', 'Small headphones that fit directly inside the ear', 'electronics', 49.99, NOW()),
('Calendar', 'Physical representation of days and months, often used for scheduling', 'stationery', 10.00, NOW()),
('Umbrella', 'Protective gear against rain or intense sun', 'accessories', 8.99, NOW()),
('Hand Sanitizer', 'Liquid or gel used to decrease infectious agents on hands', 'personal care', 2.50, NOW()),
('Sketchbook', 'Paper-filled book used for drawing or painting', 'stationery', 6.99, NOW()),
('Flash Drive', 'Portable storage device for digital files', 'electronics', 12.00, NOW()),
('Tablet Holder', 'Stand or grip for holding tablets or e-readers', 'electronics', 22.99, NOW()),
('Shampoo', 'Hair care product designed to cleanse the scalp and hair', 'personal care', 7.50, NOW()),
('Wristwatch', 'Time-telling device worn around the wrist', 'accessories', 120.00, NOW()),
('Basketball', 'Spherical sporting equipment used in basketball games', 'sports', 20.00, NOW()),
('Guitar Picks', 'Small flat tool used to strum or pick a guitar', 'music', 5.00, NOW()),
('Thermal Flask', 'Insulated bottle for keeping beverages hot or cold', 'kitchenware', 18.99, NOW()),
('Slippers', 'Soft and light footwear intended for indoor use', 'footwear', 10.00, NOW()),
('Easel', 'Upright support for artists to display or work on canvases', 'art supplies', 45.00, NOW()),
('Bicycle Helmet', 'Protective headgear for cyclists', 'sports', 35.00, NOW()),
('Candle Holder', 'Accessory to safely hold candles when they burn', 'home decor', 15.00, NOW()),
('Cutting Board', 'Durable board on which to place materials for cutting', 'kitchenware', 10.50, NOW()),
('Gardening Gloves', 'Handwear for protection during gardening tasks', 'garden', 8.00, NOW()),
('Alarm Clock', 'Time-telling device with a feature to sound at a specified time', 'electronics', 25.00, NOW()),
('Spatula', 'Flat tool used in cooking for flipping or spreading', 'kitchenware', 3.99, NOW()),
('Jigsaw Puzzle', 'Picture printed on cardboard or wood and cut into pieces to be reassembled', 'toys', 12.99, NOW()),
('Hammock', 'Sling made of fabric or netting, suspended between two points for relaxation', 'outdoor', 40.00, NOW()),
('Luggage Tag', 'Accessory attached to luggage for identification purposes', 'travel', 7.50, NOW())
;
/* </end connected objects> */

/* <begin connected objects> */
-- src/lib.rs:18
CREATE TABLE vectorize.job (
    job_id bigserial,
    name TEXT NOT NULL UNIQUE,
    index_dist_type TEXT NOT NULL DEFAULT 'pgv_hsnw_cosine',
    transformer TEXT NOT NULL,
    params jsonb NOT NULL,
    last_completion TIMESTAMP WITH TIME ZONE
);

CREATE TABLE vectorize.prompts (
    prompt_type TEXT NOT NULL UNIQUE,
    sys_prompt TEXT NOT NULL,
    user_prompt TEXT NOT NULL
);

-- allow pg_monitor to read from vectorize schema
GRANT USAGE ON SCHEMA vectorize TO pg_monitor;
GRANT SELECT ON ALL TABLES IN SCHEMA vectorize TO pg_monitor;
GRANT SELECT ON ALL SEQUENCES IN SCHEMA vectorize TO pg_monitor;
ALTER DEFAULT PRIVILEGES IN SCHEMA vectorize GRANT SELECT ON TABLES TO pg_monitor;
ALTER DEFAULT PRIVILEGES IN SCHEMA vectorize GRANT SELECT ON SEQUENCES TO pg_monitor;

CREATE OR REPLACE FUNCTION handle_table_drop()
RETURNS event_trigger AS $$
DECLARE
    obj RECORD;
    schema_name TEXT;
    table_name TEXT;
BEGIN
    FOR obj IN SELECT * FROM pg_event_trigger_dropped_objects() LOOP
        IF obj.object_type = 'table' THEN
            schema_name := split_part(obj.object_identity, '.', 1);  
            table_name := split_part(obj.object_identity, '.', 2);  
            
            -- Perform cleanup: delete the associated job from the vectorize.job table
            DELETE FROM vectorize.job
            WHERE params ->> 'table' = table_name
            AND params ->> 'schema' = schema_name;
        END IF;
    END LOOP;
END;
$$ LANGUAGE plpgsql;

DROP EVENT TRIGGER IF EXISTS vectorize_job_drop_trigger;

CREATE EVENT TRIGGER vectorize_job_drop_trigger
ON sql_drop
WHEN TAG IN ('DROP TABLE')
EXECUTE FUNCTION handle_table_drop();

INSERT INTO vectorize.prompts (prompt_type, sys_prompt, user_prompt)
VALUES (
    'question_answer',
    'You are an expert Q&A system.\nYou must always answer the question using the provided context information. Never use any prior knowledge.\nAdditional rules to follow:\n1. Never directly reference the given context in your answer.\n2. Never use responses like ''Based on the context, ...'' or ''The context information ...'' or any responses similar to that.',
    'Context information is below.\n---------------------\n{{ context_str }}\n---------------------\nGiven the context information and not prior knowledge, answer the query.\n Query: {{ query_str }}\nAnswer: '
)
ON CONFLICT (prompt_type)
DO NOTHING;
/* </end connected objects> */

/* <begin connected objects> */
-- src/types.rs:46
-- vectorize::types::IndexDist
CREATE TYPE IndexDist AS ENUM (
	'pgv_hnsw_l2',
	'pgv_hnsw_ip',
	'pgv_hnsw_cosine',
	'vsc_diskann_cosine'
);
/* </end connected objects> */

/* <begin connected objects> */
-- src/types.rs:29
-- vectorize::types::SimilarityAlg
CREATE TYPE SimilarityAlg AS ENUM (
	'pgv_cosine_similarity'
);
/* </end connected objects> */

/* <begin connected objects> */
-- src/types.rs:10
-- vectorize::types::TableMethod
CREATE TYPE TableMethod AS ENUM (
	'append',
	'join'
);
/* </end connected objects> */

/* <begin connected objects> */
-- src/job.rs:15
-- vectorize::job::_handle_table_update
CREATE  FUNCTION "_handle_table_update"(
	"job_name" TEXT, /* &str */
	"record_ids" TEXT[], /* alloc::vec::Vec<alloc::string::String> */
	"inputs" TEXT[] /* alloc::vec::Vec<alloc::string::String> */
) RETURNS void
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', '_handle_table_update_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:14
-- vectorize::api::chunk_table
CREATE  FUNCTION "chunk_table"(
	"input_table" TEXT, /* &str */
	"column_name" TEXT, /* &str */
	"primary_key" TEXT, /* &str */
	"max_chunk_size" INT DEFAULT 1000, /* i32 */
	"output_table" TEXT DEFAULT 'chunked_data' /* &str */
) RETURNS TEXT /* core::result::Result<alloc::string::String, anyhow::Error> */
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'chunk_table_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:282
-- vectorize::api::chunk_text
CREATE  FUNCTION "chunk_text"(
	"document" TEXT, /* &str */
	"max_characters" bigint /* i64 */
) RETURNS TEXT[] /* alloc::vec::Vec<alloc::string::String> */
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'chunk_text_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:173
-- vectorize::api::encode
CREATE  FUNCTION "encode"(
	"input" TEXT, /* &str */
	"model" TEXT DEFAULT 'sentence-transformers/all-MiniLM-L6-v2', /* alloc::string::String */
	"api_key" TEXT DEFAULT NULL /* core::option::Option<alloc::string::String> */
) RETURNS double precision[] /* core::result::Result<alloc::vec::Vec<f64>, anyhow::Error> */
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'encode_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:261
-- vectorize::api::env_interpolate_guc
CREATE  FUNCTION "env_interpolate_guc"(
	"guc_name" TEXT /* &str */
) RETURNS TEXT /* core::result::Result<alloc::string::String, anyhow::Error> */
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'env_interpolate_guc_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:243
-- vectorize::api::generate
CREATE  FUNCTION "generate"(
	"input" TEXT, /* &str */
	"model" TEXT DEFAULT 'tembo/meta-llama/Meta-Llama-3-8B-Instruct', /* alloc::string::String */
	"api_key" TEXT DEFAULT NULL /* core::option::Option<alloc::string::String> */
) RETURNS TEXT /* core::result::Result<alloc::string::String, anyhow::Error> */
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'generate_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:143
-- vectorize::api::hybrid_search
CREATE  FUNCTION "hybrid_search"(
	"job_name" TEXT, /* alloc::string::String */
	"query" TEXT, /* alloc::string::String */
	"api_key" TEXT DEFAULT NULL, /* core::option::Option<alloc::string::String> */
	"return_columns" TEXT[] DEFAULT ARRAY['*']::text[], /* alloc::vec::Vec<alloc::string::String> */
	"num_results" INT DEFAULT 10, /* i32 */
	"where_sql" TEXT DEFAULT NULL /* core::option::Option<alloc::string::String> */
) RETURNS TABLE (
	"search_results" jsonb  /* pgrx::datum::json::JsonB */
)
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'hybrid_search_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:184
-- vectorize::api::init_rag
CREATE  FUNCTION "init_rag"(
	"agent_name" TEXT, /* &str */
	"table_name" TEXT, /* &str */
	"unique_record_id" TEXT, /* &str */
	"column" TEXT, /* &str */
	"schema" TEXT DEFAULT 'public', /* &str */
	"index_dist_type" IndexDist DEFAULT 'pgv_hnsw_cosine', /* vectorize::types::IndexDist */
	"transformer" TEXT DEFAULT 'sentence-transformers/all-MiniLM-L6-v2', /* &str */
	"table_method" TableMethod DEFAULT 'join', /* vectorize::types::TableMethod */
	"schedule" TEXT DEFAULT '* * * * *' /* &str */
) RETURNS TEXT /* core::result::Result<alloc::string::String, anyhow::Error> */
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'init_rag_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/executor.rs:44
-- vectorize::executor::job_execute
CREATE  FUNCTION "job_execute"(
	"job_name" TEXT /* alloc::string::String */
) RETURNS void
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'job_execute_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/transformers/http_handler.rs:10
-- vectorize::transformers::http_handler::mod_info
CREATE  FUNCTION "mod_info"(
	"model_name" TEXT, /* &str */
	"api_key" TEXT DEFAULT NULL /* core::option::Option<alloc::string::String> */
) RETURNS jsonb /* pgrx::datum::json::JsonB */
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'mod_info_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:216
-- vectorize::api::rag
CREATE  FUNCTION "rag"(
	"agent_name" TEXT, /* &str */
	"query" TEXT, /* &str */
	"chat_model" TEXT DEFAULT 'tembo/meta-llama/Meta-Llama-3-8B-Instruct', /* alloc::string::String */
	"task" TEXT DEFAULT 'question_answer', /* alloc::string::String */
	"api_key" TEXT DEFAULT NULL, /* core::option::Option<alloc::string::String> */
	"num_context" INT DEFAULT 2, /* i32 */
	"force_trim" bool DEFAULT false /* bool */
) RETURNS TABLE (
	"chat_results" jsonb  /* pgrx::datum::json::JsonB */
)
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'rag_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:120
-- vectorize::api::search
CREATE  FUNCTION "search"(
	"job_name" TEXT, /* alloc::string::String */
	"query" TEXT, /* alloc::string::String */
	"api_key" TEXT DEFAULT NULL, /* core::option::Option<alloc::string::String> */
	"return_columns" TEXT[] DEFAULT ARRAY['*']::text[], /* alloc::vec::Vec<alloc::string::String> */
	"num_results" INT DEFAULT 10, /* i32 */
	"where_sql" TEXT DEFAULT NULL /* core::option::Option<alloc::string::String> */
) RETURNS TABLE (
	"search_results" jsonb  /* pgrx::datum::json::JsonB */
)
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'search_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:91
-- vectorize::api::table
CREATE  FUNCTION "table"(
	"table" TEXT, /* &str */
	"columns" TEXT[], /* alloc::vec::Vec<alloc::string::String> */
	"job_name" TEXT, /* &str */
	"primary_key" TEXT, /* &str */
	"schema" TEXT DEFAULT 'public', /* &str */
	"update_col" TEXT DEFAULT 'last_updated_at', /* alloc::string::String */
	"index_dist_type" IndexDist DEFAULT 'pgv_hnsw_cosine', /* vectorize::types::IndexDist */
	"transformer" TEXT DEFAULT 'sentence-transformers/all-MiniLM-L6-v2', /* &str */
	"table_method" TableMethod DEFAULT 'join', /* vectorize::types::TableMethod */
	"schedule" TEXT DEFAULT '* * * * *' /* &str */
) RETURNS TEXT /* core::result::Result<alloc::string::String, anyhow::Error> */
STRICT
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'table_wrapper';
/* </end connected objects> */

/* <begin connected objects> */
-- src/api.rs:163
-- vectorize::api::transform_embeddings
CREATE  FUNCTION "transform_embeddings"(
	"input" TEXT, /* &str */
	"model_name" TEXT DEFAULT 'sentence-transformers/all-MiniLM-L6-v2', /* alloc::string::String */
	"api_key" TEXT DEFAULT NULL /* core::option::Option<alloc::string::String> */
) RETURNS double precision[] /* core::result::Result<alloc::vec::Vec<f64>, anyhow::Error> */
LANGUAGE c /* Rust */
AS 'MODULE_PATHNAME', 'transform_embeddings_wrapper';
/* </end connected objects> */

